<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Dynamic Form</title>
    <style>
      section {
        margin-bottom: 20px;
      }
      h3 {
        margin-bottom: 10px;
      }
      h4 span {
        font-weight: bold;
      }
      h4.ui-state-active {
        color: #505050;
      }
      a {
        text-decoration: underline;
      }
      p {
        margin-bottom: 5px;
      }
      button {
        margin: 10px;
      }
      button.remove.ui-widget {
        font-size: 0.8em;
        margin-top: 15px;
      }
      button.ind-add-fields.ui-widget {
        font-size: 0.9em;
        margin-top: 15px;
      }
      textarea {
        display: block;
      }
      input[id*="deadline"] {
        margin-left: 15px;
        margin-right: 10px;
      }
      .deadline-date {
        display: none;
        margin-left: 15px;
        padding-left: 5px;
        border-left: 2px solid #b1b1b1;
      }
      input:not([type="radio"]):not([type="checkbox"]) {
        display: block;
        width: 60%;
        font-size: inherit;
        font-weight: normal;
        line-height: 1.2em;
        text-align: left;
        margin-bottom: 5px;
      }
      select {
        display: block;
        margin: 8px 0px 12px 10px;
      }
      .deadline-date > * {
        display: inline-block;
      }
      .deadline-date > input[type="text"] {
        width: 180px;
        display: inline-block;
      }
      select.ui-datepicker-month,
      select.ui-datepicker-year {
        background-color: #dbf171;
      }
      #message {
        display: none;
      }
    </style>
  </head>
  <body>
    <form name="Harrison" novalidate>
      <section>
        <h3>Request Individual(s) to be Assessed</h3>
        <div id="individuals"></div>
        <button type="button" class="add-fields">+ Add New Individual</button>
      </section>

      <p id="message" class="ui-state-highlight ui-corner-all"></p>
      <button type="submit" class="submit" style="background-color: #adc051">
        Confirm Purchase (<span class="qty">0</span>)
      </button>
    </form>

    <div id="template-individual" style="display: none">
      <div class="individual">
        <section>
          <label for="ind0-name">Full Name</label>
          <input
            type="text"
            id="ind0-name"
            name="candidate[0][name]"
            autocomplete="off"
          />
          <label for="ind0-email">Email</label>
          <input
            type="email"
            id="ind0-email"
            name="candidate[0][email]"
            autocomplete="off"
          />
          <label for="ind0-phone">Phone</label>
          <input
            type="tel"
            id="ind0-phone"
            name="candidate[0][phone]"
            autocomplete="off"
          />
          <label for="ind0-location">Location</label>
          <input
            type="text"
            id="ind0-location"
            name="candidate[0][location]"
            autocomplete="off"
          />
        </section>
        <section>
          <label for="ind0-role"
            >What is the current role of this individual?</label
          >
          <select id="ind0-role" name="candidate[0][role]" required>
            <option value="" selected hidden>Please Choose...</option>
            <option value="new hire">Applicant for Hire</option>
            <option value="sales manager">Sales Manager</option>
            <option value="other manager">Other Manager</option>
            <option value="other employee">Other Employee</option>
          </select>
        </section>
        <section>
          <label for="ind0-reason"
            >What is the reason for this individual's assessment?</label
          >
          <select id="ind0-reason" name="candidate[0][reason]" required>
            <option value="" selected hidden>Please Choose...</option>
            <option value="hiring">Hiring / Selection</option>
            <option value="promotion">Promotion</option>
            <option value="development">Development</option>
            <option value="team building">Team Building</option>
          </select>
        </section>
        <section>
          <label for="ind0-filter"
            >The Harrison Assessment is available for multiple positions. Please
            indicate which generic filter you wish to be applied:</label
          >
          <select id="ind0-filter" name="candidate[0][filter]" required>
            <option value="" selected hidden>Please Choose...</option>
            <option value="sales manager">Sales / Branch Manager</option>
            <option value="middle management">Middle Management</option>
            <option value="upper management">Upper Management</option>
          </select>
        </section>
        <section>
          <p>Is this assessment needed by a certain date?</p>
          <input
            type="checkbox"
            name="candidate[0][hasDeadline]"
            id="ind0-deadline"
            value="true"
          /><label for="ind0-deadline">Yes</label>
          <div class="deadline-date">
            <label for="ind0-deadline-date">Deadline</label>
            <input
              type="text"
              name="candidate[0][deadlineDate]"
              id="ind0-deadline-date"
              placeholder="mm/dd/yyyy"
            />
          </div>
        </section>
        <button type="button" class="ind-add-fields">
          + Add New Individual
        </button>
        <button type="button" class="remove ui-state-error">
          - Remove this Individual
        </button>
      </div>

      <div id="cloneCopy"></div>
    </div>

    <script src="./dropdown.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script>
      $(document).ready(function () {
        $("#individuals").accordion({
          collapsible: true,
          header: "h4",
          heightStyle: "content",
          activate: setFocus,
        });
        $("#individuals").on("accordionrefresh", StoreQuantity);
        $(".add-fields").button().on("click", cloneInd);
        $(".submit").button().on("click", checkForm);
        $("form[name='Harrison']").submit(submitForm);

        var qty = parseInt(sessionStorage["HarrisonQty"]);
        if (qty > 0) {
          for (var i = 0; qty > i; i++) {
            cloneInd();
          }
          formStorage("get", "Harrison");
        }
        $("form[name='Harrison']").show();
      });

      $.widget("ui.accordion", $.ui.accordion, {
        count: function () {
          return this.headers.length;
        },
        refresh: function () {
          this._super();
          this._trigger("refresh", null, { count: this.count() });
        },
      });
      $.datepicker.setDefaults({
        showOn: "both",
        buttonText: "Calendar",
        minDate: 2,
        showButtonPanel: true,
        changeMonth: true,
        changeYear: true,
      });

      var cloneIndex = 1;
      function cloneInd() {
        $("#template-individual  div:first-child")
          .clone()
          .appendTo("#cloneCopy");
        var template = $("#cloneCopy  div:first-child");
        template.find("*[id]").each(function () {
          replace(this, "id");
        });
        template.find("*[for]").each(function () {
          replace(this, "for");
        });
        template.find("*[name]").each(function () {
          replace(this, "name");
        });

        var clone = template
          .clone()
          .attr("id", "ind" + cloneIndex)
          .on("click", "button.remove", remove)
          .on("click", "button.ind-add-fields", triggerClone)
          .on("click", 'input[id$="deadline"]', showDate)
          .on("keyup focusout", 'input[id$="name"]', updateName);

        var header = "<h4>Request for: <span>New Individual</span></h4>";
        $("#individuals").append(header).append(clone);

        RefreshUI("#ind" + cloneIndex);

        $("#cloneCopy").html("");
        cloneIndex++;
      }

      function replace(item, elAttr) {
        var str = $(item).attr(elAttr);
        var output = str.replace(/\d+/g, cloneIndex);
        $(item).attr(elAttr, output);
      }

      function triggerClone() {
        //for button .ind-add-fields
        //setting the function cloneInd() as callback inside of cloneInd() itself caused an error
        cloneInd();
      }

      function RefreshUI(cloneId) {
        $("#individuals > " + cloneId + " button.remove").button();
        $("#individuals > " + cloneId + " button.ind-add-fields").button();

        var acc = $("#individuals");
        acc.accordion("refresh");
        if (acc.accordion("count") === 1) {
          //when one indv, close accordion in order to trigger active events
          acc.accordion("option", "active", false);
        }
        acc.accordion("option", "active", -1);
      }

      function setFocus(event, ui) {
        ui.newPanel.find("input:first").focus();
      }

      function StoreQuantity(event, ui) {
        $("button.submit .qty").html(ui.count);
      }

      function remove(e) {
        var loc = AccordionPanel($(e.target));
        loc.panel.css("display", "none").remove();
        loc.header.remove();
        $("#individuals").accordion("refresh");
        $("#individuals").accordion({ active: false });
      }

      function showDate(e) {
        var date = $(e.target).siblings(".deadline-date")[0];
        $(date).toggle(100);
        $(date).find("[id*='deadline']").datepicker();
        $("#individuals").accordion("refresh");
      }

      function updateName(e) {
        var input = $(e.target);
        var loc = AccordionPanel(input);
        var headerName = loc.header.find("span");
        var name = input.val() !== "" ? input.val() : "New Individual";

        headerName.html(name);
      }

      function AccordionPanel(elem) {
        var panel = $(elem).parents(".individual");
        var header = $("h4[aria-controls=" + panel.attr("id") + "]");
        return {
          panel: panel,
          header: header,
        };
      }

      function checkForm(e) {
        $("#message").hide();
        var indvCount = $("form .individual").length;
        if (indvCount === 0) {
          $("#message").html("Please add an Individual to be assessed.").show();
          e.preventDefault();
          return;
        }

        $("form .individual").each(function (index, el) {
          var blank = 0;
          var empty = function () {
            return $(this).val() == "";
          };
          blank += $(el)
            .find("input[type=text]:not([id*='deadline'])")
            .filter(empty).length;
          blank += $(el).find("select").filter(empty).length;
          if (blank > 0) {
            e.preventDefault();
            $("#message")
              .html(
                "Required information about Individual(" +
                  (index + 1) +
                  ") is missing"
              )
              .show();
            return;
          }
        });
      }

      function submitForm(e) {
        $("#message").hide;
        e.preventDefault();

        sessionStorage["HarrisonQty"] = $("#individuals").accordion("count");
        formStorage("set", "Harrison");

        var formObj = $("form[name='Harrison']").serializeJSON({
          checkboxUncheckedValue: "false",
          useIntKeysAsArrayIndex: "true",
        });
        /*
  $.ajax({
    type: 'GET',
    url: '/SaveAssessment',
    dataType: 'jsonp',
    data: {saveObj: JSON.stringify(formObj)}
  })
  .done(function (response) {
    if (response.message == "SUCCESS") {
      //Move User to Checkout
    } else {
      alert("The form Submit did not return as expected, please contact LeadingRE Support");
    }
  })
  .fail(function() {
    alert("The form did not submit, please contact LeadingRE Support");
  });
  */
      }

      function formStorage(type, name) {
        var saveName = "[" + name + "]";
        if (type.toLowerCase() === "set") {
          var formArray = $("form[name='" + name + "']").serializeArray();
          $.each(formArray, function (i, obj) {
            sessionStorage[obj.name + saveName] = obj.value;
          });
          return;
        }
        if (type.toLowerCase() === "get") {
          $("form *:checkbox").attr("checked", "checked");
          var formArray = $("form[name='" + name + "']").serializeArray();
          $.each(formArray, function (i, obj) {
            obj.value = sessionStorage[obj.name + saveName];
            var formItem = $("[name='" + obj.name + "']");

            if (formItem.attr("type") == "checkbox") {
              if (obj.value == "true") {
                var e = {
                  target: formItem,
                };
                showDate(e);
              } else {
                formItem.removeAttr("checked");
              }
            } else if (formItem.is("select")) {
              formItem.children("option").each(function (ii, opt) {
                $(opt).removeAttr("selected");
                if ($(opt).val() == obj.value) {
                  $(opt).attr("selected", "selected");
                }
              });
            } else {
              formItem.val(obj.value);
            }
          });
          return;
        }
        return console.log("var type accepts only 'get' or 'set'");
      }
    </script>
  </body>
</html>
